/*
 * This file contains D-Bus client proxy classes generated by qt4-client-gen.py.
 *
 * This file can be distributed under the same terms as the specification from
 * which it was generated.
 */

#ifndef IN_TELEPATHY_QT4_HEADER
#error IN_TELEPATHY_QT4_HEADER
#endif

#include <TelepathyQt4/Types>

#include <QtGlobal>

#include <QString>
#include <QObject>
#include <QVariant>

#include <QDBusPendingReply>

#include <TelepathyQt4/Client/AbstractInterface>
#include <TelepathyQt4/Client/DBusProxy>

// basically the same as GLib's G_GNUC_DEPRECATED
#ifndef TELEPATHY_GNUC_DEPRECATED
#   if defined(Q_CC_GNUC) && __GNUC__ >= 4
#       define TELEPATHY_GNUC_DEPRECATED __attribute__((__deprecated__))
#   else
#       define TELEPATHY_GNUC_DEPRECATED
#   endif
#endif
namespace Telepathy
{
namespace Client
{

/**
 * \class AccountManagerInterface
 * \headerfile TelepathyQt4/Client/account-manager.h <TelepathyQt4/Client/AccountManager>
 * \ingroup clientam
 *
 * Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.AccountManager."
 */
class AccountManagerInterface : public Telepathy::Client::AbstractInterface
{
    Q_OBJECT

public:
    /**
     * Returns the name of the interface "org.freedesktop.Telepathy.AccountManager", which this class
     * represents.
     *
     * \return The D-Bus interface name.
     */
    static inline const char *staticInterfaceName()
    {
        return "org.freedesktop.Telepathy.AccountManager";
    }

    /**
     * Creates a AccountManagerInterface associated with the given object on the session bus.
     *
     * \param serviceName Name of the service the object is on.
     * \param objectPath Path to the object on the service.
     * \param parent Passed to the parent class constructor.
     */
    AccountManagerInterface(
        const QString& serviceName,
        const QString& objectPath,
        QObject* parent = 0
    );

    /**
     * Creates a AccountManagerInterface associated with the given object on the given bus.
     *
     * \param connection The bus via which the object can be reached.
     * \param serviceName Name of the service the object is on.
     * \param objectPath Path to the object on the service.
     * \param parent Passed to the parent class constructor.
     */
    AccountManagerInterface(
        const QDBusConnection& connection,
        const QString& serviceName,
        const QString& objectPath,
        QObject* parent = 0
    );

    /**
     * Creates a AccountManagerInterface associated with the same object as the given proxy.
     *
     * \param proxy The proxy to use. It will also be the QObject::parent()
     *               for this object.
     */
    AccountManagerInterface(Telepathy::Client::DBusProxy *proxy);

    /**
     * Represents property "Interfaces" on the remote object.
     * 
     * A list of the interfaces provided by the account manager object.
     */
    Q_PROPERTY(QStringList Interfaces READ Interfaces)

    /**
     * Getter for the remote object property "Interfaces".
     *
     * Don't use this: it blocks the main loop.
     *
     * \return The value of the property, or a default-constructed value
     *          if the property is not readable.
     */
    inline QStringList Interfaces() const TELEPATHY_GNUC_DEPRECATED
    {
        return qvariant_cast<QStringList>(internalPropGet("Interfaces"));
    }

    /**
     * Represents property "ValidAccounts" on the remote object.
     * 
     * A list of the valid (complete, usable) accounts. Change notification is 
     * via AccountValidityChanged. This split between valid and invalid 
     * accounts makes it easy to ignore the invalid ones. The only things that 
     * should be manipulating invalid accounts are account-editing UIs, which 
     * might be able to rescue them.
     */
    Q_PROPERTY(Telepathy::ObjectPathList ValidAccounts READ ValidAccounts)

    /**
     * Getter for the remote object property "ValidAccounts".
     *
     * Don't use this: it blocks the main loop.
     *
     * \return The value of the property, or a default-constructed value
     *          if the property is not readable.
     */
    inline Telepathy::ObjectPathList ValidAccounts() const TELEPATHY_GNUC_DEPRECATED
    {
        return qvariant_cast<Telepathy::ObjectPathList>(internalPropGet("ValidAccounts"));
    }

    /**
     * Represents property "InvalidAccounts" on the remote object.
     * 
     * A list of incomplete or otherwise unusable accounts. Change 
     * notification is via AccountValidityChanged.
     */
    Q_PROPERTY(Telepathy::ObjectPathList InvalidAccounts READ InvalidAccounts)

    /**
     * Getter for the remote object property "InvalidAccounts".
     *
     * Don't use this: it blocks the main loop.
     *
     * \return The value of the property, or a default-constructed value
     *          if the property is not readable.
     */
    inline Telepathy::ObjectPathList InvalidAccounts() const TELEPATHY_GNUC_DEPRECATED
    {
        return qvariant_cast<Telepathy::ObjectPathList>(internalPropGet("InvalidAccounts"));
    }

public Q_SLOTS:
    /**
     * Begins a call to the D-Bus method "CreateAccount" on the remote object.
     * 
     * Request the creation of a new Account. The account manager SHOULD NOT 
     * allow invalid accounts to be created.
     *
     * \param connectionManager
     *     
     *     The name of the connection manager, e.g. &quot;salut&quot;.
     *
     * \param protocol
     *     
     *     The protocol, e.g. &quot;local-xmpp&quot;.
     *
     * \param displayName
     *     
     *     The initial value of the new account&apos;s DisplayName property. 
     *     The account manager SHOULD modify this to make it unique if an 
     *     Account already exists with the same display name, for instance by 
     *     appending a number or the &apos;account&apos; parameter. Account 
     *     manager implementations SHOULD accept an empty string but account 
     *     editing user interfaces should avoid passing an empty string for 
     *     this parameter. The account creation UI may ask the user for a name 
     *     for the new account. If the author of the UI chooses not to do 
     *     this, the account creation UI is better able to suggest a default 
     *     display name because it has protocol-specific knowledge which the 
     *     account manager does not. The account manager always knows the 
     *     complete list of accounts so it can easily tell whether it should 
     *     append something to the display name to avoid presenting two 
     *     identically-named accounts to the user.
     *
     * \param parameters
     *     
     *     Initial parameter values, as would be passed to RequestConnection.
     *
     * \return
     *     
     *     The new Account.
     */
    inline QDBusPendingReply<QDBusObjectPath> CreateAccount(const QString& connectionManager, const QString& protocol, const QString& displayName, const QVariantMap& parameters)
    {
        if (!invalidationReason().isEmpty()) {
            return QDBusPendingReply<QDBusObjectPath>(QDBusMessage::createError(
                invalidationReason(),
                invalidationMessage()
            ));
        }


        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(connectionManager) << QVariant::fromValue(protocol) << QVariant::fromValue(displayName) << QVariant::fromValue(parameters);
        return asyncCallWithArgumentList(QLatin1String("CreateAccount"), argumentList);
    }

Q_SIGNALS:
    /**
     * Represents the signal "AccountRemoved" on the remote object.
     * 
     * The given account has been removed. This is effectively change 
     * notification for the valid and invalid accounts lists. On emission of 
     * this signal, the Account indicated will no longer be present in either 
     * of the lists.
     *
     * \param account
     *     
     *     An Account, which must not be used any more.
     */
    void AccountRemoved(const QDBusObjectPath& account);

    /**
     * Represents the signal "AccountValidityChanged" on the remote object.
     * 
     * The validity of the given account has changed. New accounts are also 
     * indicated by this signal, as an account validity change (usually to 
     * True) on an account that did not previously exist. This is effectively 
     * change notification for the valid and invalid accounts lists.
     *
     * \param account
     *     
     *     An Account.
     *
     * \param valid
     *     
     *     True if the account is now valid.
     */
    void AccountValidityChanged(const QDBusObjectPath& account, bool valid);

protected:
    virtual void invalidate(Telepathy::Client::DBusProxy *, const QString &, const QString &);
};
}
}
