/*
 * This file contains D-Bus client proxy classes generated by qt4-client-gen.py.
 *
 * This file can be distributed under the same terms as the specification from
 * which it was generated.
 */

#include <TelepathyQt4/Types>
#include <TelepathyQt4/Prototype/Types>

#include <QtGlobal>

#include <QString>
#include <QObject>
#include <QVariant>

#include <QDBusPendingReply>

#include <TelepathyQt4/Client/AbstractInterface>
#include <TelepathyQt4/Client/DBusProxy>

// basically the same as GLib's G_GNUC_DEPRECATED
#ifndef TELEPATHY_GNUC_DEPRECATED
#   if defined(Q_CC_GNUC) && __GNUC__ >= 4
#       define TELEPATHY_GNUC_DEPRECATED __attribute__((__deprecated__))
#   else
#       define TELEPATHY_GNUC_DEPRECATED
#   endif
#endif
namespace TpPrototype
{
namespace Client
{

/**
 * \class ChannelHandlerInterface
 * \headerfile TelepathyQt4/Prototype/cli-channel-handler.h <TelepathyQt4/Prototype/Client/ChannelHandler>
 * \ingroup clientchannelhandler
 *
 * Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.ChannelHandler."
 */
class ChannelHandlerInterface : public Telepathy::Client::AbstractInterface
{
    Q_OBJECT

public:
    /**
     * Returns the name of the interface "org.freedesktop.Telepathy.ChannelHandler", which this class
     * represents.
     *
     * \return The D-Bus interface name.
     */
    static inline const char *staticInterfaceName()
    {
        return "org.freedesktop.Telepathy.ChannelHandler";
    }

    /**
     * Creates a ChannelHandlerInterface associated with the given object on the session bus.
     *
     * \param serviceName Name of the service the object is on.
     * \param objectPath Path to the object on the service.
     * \param parent Passed to the parent class constructor.
     */
    ChannelHandlerInterface(
        const QString& serviceName,
        const QString& objectPath,
        QObject* parent = 0
    );

    /**
     * Creates a ChannelHandlerInterface associated with the given object on the given bus.
     *
     * \param connection The bus via which the object can be reached.
     * \param serviceName Name of the service the object is on.
     * \param objectPath Path to the object on the service.
     * \param parent Passed to the parent class constructor.
     */
    ChannelHandlerInterface(
        const QDBusConnection& connection,
        const QString& serviceName,
        const QString& objectPath,
        QObject* parent = 0
    );

    /**
     * Creates a ChannelHandlerInterface associated with the same object as the given proxy.
     *
     * \param proxy The proxy to use. It will also be the QObject::parent()
     *               for this object.
     */
    ChannelHandlerInterface(Telepathy::Client::DBusProxy *proxy);

    /**
     * Creates a ChannelHandlerInterface associated with the same object as the given proxy.
     * Additionally, the created proxy will have the same parent as the given
     * proxy.
     *
     * \param mainInterface The proxy to use.
     */
    explicit ChannelHandlerInterface(const Telepathy::Client::AbstractInterface& mainInterface);

    /**
     * Creates a ChannelHandlerInterface associated with the same object as the given proxy.
     * However, a different parent object can be specified.
     *
     * \param mainInterface The proxy to use.
     * \param parent Passed to the parent class constructor.
     */
    ChannelHandlerInterface(const Telepathy::Client::AbstractInterface& mainInterface, QObject* parent);

public Q_SLOTS:
    /**
     * Begins a call to the D-Bus method "HandleChannel" on the remote object.
     * 
     * Called when a channel handler should handle a new channel.
     *
     * \param busName
     *     
     *     The bus name of the connection and channel
     *
     * \param connection
     *     
     *     The object-path of the connection that owns the channel
     *
     * \param channelType
     *     
     *     The channel type
     *
     * \param channel
     *     
     *     The object-path of the channel
     *
     * \param handleType
     *     
     *     The type of the handle that the channel communicates with, or 0 if 
     *     there is no associated handle
     *
     * \param handle
     *     
     *     The handle that the channel communicates with, or 0 if there is no 
     *     associated handle
     */
    inline QDBusPendingReply<> HandleChannel(const QString& busName, const QDBusObjectPath& connection, const QString& channelType, const QDBusObjectPath& channel, uint handleType, uint handle)
    {
        if (!invalidationReason().isEmpty()) {
            return QDBusPendingReply<>(QDBusMessage::createError(
                invalidationReason(),
                invalidationMessage()
            ));
        }


        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(busName) << QVariant::fromValue(connection) << QVariant::fromValue(channelType) << QVariant::fromValue(channel) << QVariant::fromValue(handleType) << QVariant::fromValue(handle);
        return asyncCallWithArgumentList(QLatin1String("HandleChannel"), argumentList);
    }

protected:
    virtual void invalidate(Telepathy::Client::DBusProxy *, const QString &, const QString &);
};
}
}
