/*
 * This file contains D-Bus client proxy classes generated by qt4-client-gen.py.
 *
 * This file can be distributed under the same terms as the specification from
 * which it was generated.
 */

#include <TelepathyQt4/Types>
#include <TelepathyQt4/Prototype/Types>

#include <QtGlobal>

#include <QString>
#include <QObject>
#include <QVariant>

#include <QDBusPendingReply>

#include <TelepathyQt4/Client/AbstractInterface>
#include <TelepathyQt4/Client/DBusProxy>

// basically the same as GLib's G_GNUC_DEPRECATED
#ifndef TELEPATHY_GNUC_DEPRECATED
#   if defined(Q_CC_GNUC) && __GNUC__ >= 4
#       define TELEPATHY_GNUC_DEPRECATED __attribute__((__deprecated__))
#   else
#       define TELEPATHY_GNUC_DEPRECATED
#   endif
#endif
namespace TpPrototype
{
namespace Client
{

/**
 * \class StreamEngineInterface
 * \headerfile TelepathyQt4/Prototype/cli-stream-engine.h <TelepathyQt4/Prototype/Client/StreamEngine>
 * \ingroup clientstreamengine
 *
 * Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.StreamEngine."
 */
class StreamEngineInterface : public Telepathy::Client::AbstractInterface
{
    Q_OBJECT

public:
    /**
     * Returns the name of the interface "org.freedesktop.Telepathy.StreamEngine", which this class
     * represents.
     *
     * \return The D-Bus interface name.
     */
    static inline const char *staticInterfaceName()
    {
        return "org.freedesktop.Telepathy.StreamEngine";
    }

    /**
     * Creates a StreamEngineInterface associated with the given object on the session bus.
     *
     * \param serviceName Name of the service the object is on.
     * \param objectPath Path to the object on the service.
     * \param parent Passed to the parent class constructor.
     */
    StreamEngineInterface(
        const QString& serviceName,
        const QString& objectPath,
        QObject* parent = 0
    );

    /**
     * Creates a StreamEngineInterface associated with the given object on the given bus.
     *
     * \param connection The bus via which the object can be reached.
     * \param serviceName Name of the service the object is on.
     * \param objectPath Path to the object on the service.
     * \param parent Passed to the parent class constructor.
     */
    StreamEngineInterface(
        const QDBusConnection& connection,
        const QString& serviceName,
        const QString& objectPath,
        QObject* parent = 0
    );

    /**
     * Creates a StreamEngineInterface associated with the same object as the given proxy.
     *
     * \param proxy The proxy to use. It will also be the QObject::parent()
     *               for this object.
     */
    StreamEngineInterface(Telepathy::Client::DBusProxy *proxy);

    /**
     * Creates a StreamEngineInterface associated with the same object as the given proxy.
     * Additionally, the created proxy will have the same parent as the given
     * proxy.
     *
     * \param mainInterface The proxy to use.
     */
    explicit StreamEngineInterface(const Telepathy::Client::AbstractInterface& mainInterface);

    /**
     * Creates a StreamEngineInterface associated with the same object as the given proxy.
     * However, a different parent object can be specified.
     *
     * \param mainInterface The proxy to use.
     * \param parent Passed to the parent class constructor.
     */
    StreamEngineInterface(const Telepathy::Client::AbstractInterface& mainInterface, QObject* parent);

public Q_SLOTS:
    /**
     * Begins a call to the D-Bus method "SetOutputVolume" on the remote object.
     */
    inline QDBusPendingReply<> SetOutputVolume(const QDBusObjectPath& channelpath, uint streamid, uint volume)
    {
        if (!invalidationReason().isEmpty()) {
            return QDBusPendingReply<>(QDBusMessage::createError(
                invalidationReason(),
                invalidationMessage()
            ));
        }


        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(channelpath) << QVariant::fromValue(streamid) << QVariant::fromValue(volume);
        return asyncCallWithArgumentList(QLatin1String("SetOutputVolume"), argumentList);
    }

    /**
     * Begins a call to the D-Bus method "MuteInput" on the remote object.
     */
    inline QDBusPendingReply<> MuteInput(const QDBusObjectPath& channelpath, uint streamid, bool mutestate)
    {
        if (!invalidationReason().isEmpty()) {
            return QDBusPendingReply<>(QDBusMessage::createError(
                invalidationReason(),
                invalidationMessage()
            ));
        }


        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(channelpath) << QVariant::fromValue(streamid) << QVariant::fromValue(mutestate);
        return asyncCallWithArgumentList(QLatin1String("MuteInput"), argumentList);
    }

    /**
     * Begins a call to the D-Bus method "MuteOutput" on the remote object.
     */
    inline QDBusPendingReply<> MuteOutput(const QDBusObjectPath& channelpath, uint streamid, bool mutestate)
    {
        if (!invalidationReason().isEmpty()) {
            return QDBusPendingReply<>(QDBusMessage::createError(
                invalidationReason(),
                invalidationMessage()
            ));
        }


        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(channelpath) << QVariant::fromValue(streamid) << QVariant::fromValue(mutestate);
        return asyncCallWithArgumentList(QLatin1String("MuteOutput"), argumentList);
    }

    /**
     * Begins a call to the D-Bus method "SetOutputWindow" on the remote object.
     */
    inline QDBusPendingReply<> SetOutputWindow(const QDBusObjectPath& channelpath, uint streamid, uint window)
    {
        if (!invalidationReason().isEmpty()) {
            return QDBusPendingReply<>(QDBusMessage::createError(
                invalidationReason(),
                invalidationMessage()
            ));
        }


        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(channelpath) << QVariant::fromValue(streamid) << QVariant::fromValue(window);
        return asyncCallWithArgumentList(QLatin1String("SetOutputWindow"), argumentList);
    }

    /**
     * Begins a call to the D-Bus method "AddPreviewWindow" on the remote object.
     */
    inline QDBusPendingReply<> AddPreviewWindow(uint window)
    {
        if (!invalidationReason().isEmpty()) {
            return QDBusPendingReply<>(QDBusMessage::createError(
                invalidationReason(),
                invalidationMessage()
            ));
        }


        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(window);
        return asyncCallWithArgumentList(QLatin1String("AddPreviewWindow"), argumentList);
    }

    /**
     * Begins a call to the D-Bus method "RemovePreviewWindow" on the remote object.
     */
    inline QDBusPendingReply<> RemovePreviewWindow(uint window)
    {
        if (!invalidationReason().isEmpty()) {
            return QDBusPendingReply<>(QDBusMessage::createError(
                invalidationReason(),
                invalidationMessage()
            ));
        }


        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(window);
        return asyncCallWithArgumentList(QLatin1String("RemovePreviewWindow"), argumentList);
    }

    /**
     * Begins a call to the D-Bus method "Shutdown" on the remote object.
     */
    inline QDBusPendingReply<> Shutdown()
    {
        if (!invalidationReason().isEmpty()) {
            return QDBusPendingReply<>(QDBusMessage::createError(
                invalidationReason(),
                invalidationMessage()
            ));
        }


        return asyncCall(QLatin1String("Shutdown"));
    }

Q_SIGNALS:
    /**
     * Represents the signal "Receiving" on the remote object.
     */
    void Receiving(const QDBusObjectPath& channelpath, uint streamid, bool state);

    /**
     * Represents the signal "StreamStateChanged" on the remote object.
     */
    void StreamStateChanged(const QDBusObjectPath& channelpath, uint streamid, uint state, uint direction);

protected:
    virtual void invalidate(Telepathy::Client::DBusProxy *, const QString &, const QString &);
};
}
}
